//www.elegoo.com
//2016.12.12

#include "Stepper.h"
#include "LiquidCrystal.h"
#include "Keypad.h"

const int sw5 = 31;
const int sw6 = 33;
const int sw7 = 35;
const int sw8 = 37; 

const int lockPin = 24;


const int redLEDPin = 26;
const int greenLEDPin = 30;

const byte ROWS = 4; //four rows
const byte COLS = 4; //four columns
//define the cymbols on the buttons of the keypads
char hexaKeys[ROWS][COLS] = {
  {'1','2','3','A'},
  {'4','5','6','B'},
  {'7','8','9','C'},
  {'*','0','#','D'}
};
byte rowPins[ROWS] = {38, 40, 42, 44}; //connect to the row pinouts of the keypad
byte colPins[COLS] = {46, 48, 50, 52}; //connect to the column pinouts of the keypad

//initialize an instance of class NewKeypad
Keypad customKeypad = Keypad( makeKeymap(hexaKeys), rowPins, colPins, ROWS, COLS); 


 

int kPadAOpen =0;
int kPadBOpen =0;
int kPadCOpen =0;
int stepsTaken =0;
int stepsPerRev;
long stepsB;
long oneRev = 400;
 long oneStep;
long motorSetting;
double stepsPerRevA;
double stepsPerRevB;
int fullSteps;
float degreesPerStep;
float extraDegrees;
char outStr[15];
int startSpeed =100;
int runSpeed =100;
float mDiv = 1000;
 int keyApressNum;
 int val;
 int locked;

/*----- Variables, Pins -----*/
#define STEPS 1600 // Number of steps per revolution of Internal shaft
//int  StepsToTake=200;  // 2048 = 1 Revolution
/*-----( Declare objects )-----*/
// Setup of proper sequencing for Motor Driver Pins
// In1, In2, In3, In4 in the sequence 1-3-2-4

Stepper small_stepper(STEPS, 8, 10, 9, 11);


LiquidCrystal lcd(2,3,43,45,47,49);
int steps = 0;




void setup()
{ 
   pinMode(sw5, OUTPUT);
 pinMode(sw6, OUTPUT);
 pinMode(sw7, OUTPUT);
 pinMode(sw8, OUTPUT);
 
 pinMode(lockPin, OUTPUT);

pinMode(redLEDPin, OUTPUT);
pinMode(greenLEDPin, OUTPUT);

     
 
lcd.begin (20,4);


lcd.setCursor(0,0);
lcd.print("Stps:");
lcd.setCursor(10,0);  
lcd.print("#:");
lcd.setCursor(0,1);
lcd.print("Goto:");
lcd.setCursor(0,2);
lcd.print("motor:");
small_stepper.setSpeed(100);
lcd.setCursor(0,3);
    lcd.print("Speed:");
    lcd.print(startSpeed);


  
}





void loop()

{
  val = digitalRead(lockPin); 
  
  // read input value
  
  
  
  if (val == 0) {         // check if the input is HIGH (button released)
   digitalWrite(redLEDPin,0);
  digitalWrite(greenLEDPin,1); 
  locked = 0;

  
  
  }
if (val == 1) { 
   digitalWrite(redLEDPin,1);
  digitalWrite(greenLEDPin,0);
locked = 1;
  
 }
  


  
   char customKey = customKeypad.getKey();
   
     digitalWrite(8, LOW);
     digitalWrite(9, LOW);
     digitalWrite(10, LOW);
     digitalWrite(11, LOW);
  
  if (customKey){
    

    
    
    switch (customKey) {
      
      case 'A':
      kPadAOpen = 1;
      keyApressNum = 0;
      stepsPerRev =0;
      stepsTaken =0;
    
    lcd.setCursor(5,0);
    lcd.print("     ");
    lcd.setCursor(5,0);
    
    while (kPadAOpen == 1){
      char customAKey;
      customAKey = customKeypad.getKey();
   if (customAKey ){
    
    switch (customAKey){
      case'A':
      kPadAOpen = 0;
      
      break;
      
      default:
      
      if (customAKey and keyApressNum < 4){
      keyApressNum ++;
      lcd.print(customAKey);
      
      switch (stepsPerRev){
        
      case 0:
      stepsPerRev = (customAKey-48);
      break;
      default:
      stepsPerRev = stepsPerRev *10 +(customAKey-48);
      break;
        
      }
      }
      break;
      }
    }
    
    
    
    }
    
   
    motorSetting = optimize(stepsPerRev);
    
    
    
    
    oneRev = motorSetting * 240;
    oneStep = oneRev/stepsPerRev;
    
 
   /*lcd.setCursor(0,3);
  lcd.print("        ");
   lcd.setCursor(0,3);*/
  
  
  degreesPerStep = (21600.00/((float)stepsPerRev));
  

 // lcd.print(degreesPerStep);
  
  extraDegrees = degreesPerStep;
  
  while (extraDegrees >= 360)
  {
    extraDegrees = (float)(extraDegrees - 360L);
  }
  
  
  
 // lcd.print(" ");
 //  lcd.print(extraDegrees);
  
  lcd.setCursor(14,2);
  lcd.print("      ");
  lcd.setCursor(14,2);
  lcd.print(degreesPerStep/60L);
  
  
  //small_stepper.setSpeed(abs(motorSetting));
    
  

    
      break;
      
      case 'B':
      // goto particular step
      if (locked == 0){
       kPadAOpen = 1;
      keyApressNum = 0;
    
    lcd.setCursor(5,1);
    lcd.print("    ");
    lcd.setCursor(5,1);
    
    while (kPadAOpen == 1){
      
      int stepToGoTo;
     char customAKey = customKeypad.getKey();
   if (customAKey ){
    
    switch (customAKey){
      case'B':
      kPadAOpen = 0;
gotoStep(stepToGoTo);
      break;
      
      default:
      
      if (customAKey and keyApressNum < 4){
      keyApressNum ++;
      lcd.print(customAKey);
      
      switch (stepToGoTo){
        
      case 0:
      stepToGoTo = (customAKey-48);
      break;
      default:
      stepToGoTo = stepToGoTo *10 +(customAKey-48);
      break;
        
      }
      break;
      }                      }
    }
    }
      }
      break;
      
      
      case'D':
      if (locked ==0){
     if (stepsTaken > 0){ 
        
        gotoStep (stepsTaken-1);
      
       lcd.setCursor(12,0);
      lcd.print("    ");
      lcd.setCursor(12,0);
      lcd.print(stepsTaken);
      
      }
      }
      break;
      
       case'C':
       if (locked ==0){
       if (stepsTaken < stepsPerRev){
      
     gotoStep (stepsTaken +1);
      
       
      lcd.setCursor(12,0);
      lcd.print("    ");
      lcd.setCursor(12,0);
      lcd.print(stepsTaken);
      }
       }
      break;
      
      case '*':
      // set speed
      
       kPadAOpen = 1;
      keyApressNum = 0;
      runSpeed=0;
    
    lcd.setCursor(6,3);
    lcd.print("    ");
    lcd.setCursor(6,3);
    
    while (kPadAOpen == 1){
      
      int stepToGoTo;
     char customAKey = customKeypad.getKey();
   if (customAKey ){
    
    switch (customAKey){
      case'*':
      kPadAOpen = 0;
startSpeed = runSpeed;
      break;
      
      default:
      
      if (customAKey and keyApressNum < 4){
      keyApressNum ++;
      lcd.print(customAKey);
      
      switch (runSpeed){
        
      case 0:
      runSpeed = (customAKey-48);
      break;
      default:
      runSpeed = runSpeed *10 +(customAKey-48);
      break;
        
      }
      break;
      }                      }
    }
    }
      
      break;
      
      default:
      break;
      
    
    }
    }
  }
  
  
  
  int gotoStep (int stepToGoTo)
  {
          if (stepToGoTo > stepsTaken and stepToGoTo < (stepsPerRev+1))
      {
        
      stepsB = (oneStep)*(stepToGoTo-stepsTaken);
     
      
      stepsTaken = stepToGoTo;
      
 if (stepsB > mDiv){
   
   fullSteps = (stepsB/(mDiv *1L) );
 
 for (int i = 0; i < fullSteps; i++)
  {
    if (i < 1 or i > fullSteps -2){
      small_stepper.setSpeed(startSpeed);
    }
 else {
   small_stepper.setSpeed(runSpeed);
 }
    small_stepper.step(mDiv);
     
  }
 
    small_stepper.step(stepsB - (fullSteps * mDiv));
      
      
 }
 
 else 
 {small_stepper.step(stepsB);
      }
      }
      if (stepToGoTo < stepsTaken)
      {
        stepsB = (oneStep)*(stepsTaken - stepToGoTo);
     
      
      stepsTaken = stepToGoTo;
      
 if (stepsB > mDiv){
   
   fullSteps = (stepsB/(mDiv *1L));
 
 for (int i = 0; i < fullSteps; i++)
  {
    if (i < 1 or i > fullSteps -2){
      small_stepper.setSpeed(startSpeed);
    }
 else {
   small_stepper.setSpeed(runSpeed);
 }
 
    small_stepper.step(-mDiv);
     
  }

    small_stepper.step(-(stepsB - (fullSteps *mDiv)));
      
      
 }
 
 else 
 {small_stepper.step(-stepsB);
      }
      }
      
      lcd.setCursor(12,0);
      lcd.print("    ");
      lcd.setCursor(12,0);
      lcd.print(stepsTaken);
      lcd.setCursor(14,2);
      lcd.print("      ");
      lcd.setCursor(14,2);
      lcd.print(stepsTaken*(degreesPerStep/60L));
  }
  
  //end function
  
  long optimize(int stepsPerRev)
{
  long possibles[4] = {400,800,1600,1000};
  int motorOptions = 4;
  float microsteps;
  float stepsreq;
  long optimum;
  float error; 
  error=1000;
  
  for (int i = 0; i < motorOptions; i++)
  {
 
   
   
   float degreesPerStep;
    int offAmount;
     int rndMicro;
      double result;
  
  stepsreq = stepsPerRev;
  
  microsteps = abs(possibles[i] * 240);
  
  result = (microsteps/stepsreq);
  
  rndMicro = (float)(result+0.5);
  
  offAmount = (rndMicro * stepsreq)- microsteps;
  
  degreesPerStep = (360/microsteps);
 
  
  
  
  if (abs(degreesPerStep*offAmount) < error){
  error = abs(degreesPerStep*offAmount);
  optimum = possibles[i];

  
  
  }
 

 
  }
  
   lcd.setCursor(7,2);
  lcd.print("       ");
  lcd.setCursor(7,2);
  
  switch (abs(optimum)){
  case 400:
  
  lcd.print("400");
   digitalWrite(sw5, LOW);
      digitalWrite(sw6, LOW);
      digitalWrite(sw7, LOW);
      digitalWrite(sw8, LOW);
  
  
  break;
  
  case 800:

  lcd.print("800");
   digitalWrite(sw5, LOW);
      digitalWrite(sw6, HIGH);
      digitalWrite(sw7, LOW);
      digitalWrite(sw8, LOW);
  
  
  break;
  
  case 1600:
  
  lcd.print("1600");
   digitalWrite(sw5, LOW);
      digitalWrite(sw6, LOW);
      digitalWrite(sw7, HIGH);
      digitalWrite(sw8, LOW);
  
  break;
  
  case 3200:
  
  lcd.print("3200");
   digitalWrite(sw5, LOW);
      digitalWrite(sw6, HIGH);
      digitalWrite(sw7, HIGH);
      digitalWrite(sw8, LOW);
  
  break;
  
  case 6400:

  lcd.print("6400");
   digitalWrite(sw5, LOW);
      digitalWrite(sw6, LOW);
      digitalWrite(sw7, LOW);
      digitalWrite(sw8, HIGH);
  
  break;
  
  case 12800:
  
  lcd.print("12800");
   digitalWrite(sw5, LOW);
      digitalWrite(sw6, HIGH);
      digitalWrite(sw7, LOW);
      digitalWrite(sw8, HIGH);
  
  break;
  
  case 25600:
  
  lcd.print("25600");
  
   digitalWrite(sw5, LOW);
      digitalWrite(sw6, LOW);
      digitalWrite(sw7, HIGH);
      digitalWrite(sw8, HIGH);
  
  break;
  
  case 51200:
  
  lcd.print("51200");
   digitalWrite(sw5, LOW);
      digitalWrite(sw6, HIGH);
      digitalWrite(sw7, HIGH);
      digitalWrite(sw8, HIGH);
  
  break;
  
  case 1000:
 
  lcd.print("1000");
   digitalWrite(sw5, HIGH);
      digitalWrite(sw6, LOW);
      digitalWrite(sw7, LOW);
      digitalWrite(sw8, LOW);

  
  break;
  
  case 2000:
 
  lcd.print("2000");
   digitalWrite(sw5, HIGH);
      digitalWrite(sw6, HIGH);
      digitalWrite(sw7, LOW);
      digitalWrite(sw8, LOW);

  
  break;
  
  case 5000:
 
  lcd.print("5000");
  
   digitalWrite(sw5, HIGH);
      digitalWrite(sw6, LOW);
      digitalWrite(sw7, HIGH);
      digitalWrite(sw8, LOW);
  
  break;
  
  case 10000:
  
  lcd.print("10000");
   digitalWrite(sw5, HIGH);
      digitalWrite(sw6, HIGH);
      digitalWrite(sw7, HIGH);
      digitalWrite(sw8, LOW);
  
  
  break;
  
  case 25000:
 
  lcd.print("25000");
   digitalWrite(sw5, HIGH);
      digitalWrite(sw6, LOW);
      digitalWrite(sw7, LOW);
      digitalWrite(sw8, HIGH);
 
  
  break;
  
  case 50000:
 
  lcd.print("50000");
   digitalWrite(sw5, HIGH);
      digitalWrite(sw6, HIGH);
      digitalWrite(sw7, LOW);
      digitalWrite(sw8, HIGH);

  
  break;
}
  
  
  return (optimum);
}
  
